﻿Imports ZXing
Imports ZXing.Common

Imports jp.co.systembase.report.component
Imports ZXing.Datamatrix
Imports ZXing.Datamatrix.Encoder
Imports jp.co.systembase.report.renderer.gdi
Imports jp.co.systembase.report
Imports jp.co.systembase.report.renderer.gdi.elementrenderer

Public Class GdiDataMatrixRenderer
    Implements IElementRenderer

    Public Sub Render(env As RenderingEnv, reportDesign As ReportDesign, region As component.Region, design As ElementDesign, data As Object) Implements IElementRenderer.Render
        Dim code As String = Nothing
        If env.InDesigner Then
            code = "DATAMATRRIX"
        Else
            Dim fd As ElementDesign = design.Child("formatter")
            code = reportDesign.Setting.GetTextFormatter(fd.Get("type")).Format(data, fd)
        End If


        Dim _region As Region = region.ToPointScale(reportDesign)
        Dim g As Drawing.Graphics = env.Graphics
        Try
            Dim w As New DataMatrixWriter
            Dim h As New Dictionary(Of EncodeHintType, Object)
            If Not design.IsNull("datamatrix_shape") Then
                Select Case design.Get("datamatrix_shape")
                    Case "square"
                        h.Add(EncodeHintType.DATA_MATRIX_SHAPE, SymbolShapeHint.FORCE_SQUARE)
                    Case "rectangle"
                        h.Add(EncodeHintType.DATA_MATRIX_SHAPE, SymbolShapeHint.FORCE_RECTANGLE)
                End Select
            Else
                h.Add(EncodeHintType.DATA_MATRIX_SHAPE, SymbolShapeHint.FORCE_SQUARE)
            End If

            Dim bm As BitMatrix = w.encode(code, BarcodeFormat.DATA_MATRIX, 0, 0, h)
            Dim mw As Single = _region.GetWidth / bm.Width
            Dim mh As Single = _region.GetHeight / bm.Height
            For y As Integer = 0 To bm.Height - 1
                For x As Integer = 0 To bm.Width - 1
                    If bm(x, y) Then
                        g.FillRectangle(Drawing.Brushes.Black, _region.Left + mw * x, _region.Top + mh * y, mw, mh)
                    End If
                Next
            Next
        Catch ex As Exception
        End Try
    End Sub

End Class
